/* help.c generated by valac 0.16.1, the Vala compiler
 * generated from help.vala, do not modify */

/*

This file is part of Auditive.

Copyright 2010-2012 Graeme Sheppard.

Auditive is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Auditive is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Auditive. If not, see <http://www.gnu.org/licenses/>.

*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_SCREEN (screen_get_type ())
#define SCREEN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCREEN, screen))
#define SCREEN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCREEN, screenClass))
#define IS_SCREEN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCREEN))
#define IS_SCREEN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCREEN))
#define SCREEN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCREEN, screenClass))

typedef struct _screen screen;
typedef struct _screenClass screenClass;
typedef struct _screenPrivate screenPrivate;

#define WORLD_WIDE_TYPE_SCREEN_TYPE (world_wide_screen_type_get_type ())

#define TYPE_WORLD_WIDE (world_wide_get_type ())
#define WORLD_WIDE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORLD_WIDE, world_wide))
#define WORLD_WIDE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORLD_WIDE, world_wideClass))
#define IS_WORLD_WIDE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORLD_WIDE))
#define IS_WORLD_WIDE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORLD_WIDE))
#define WORLD_WIDE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORLD_WIDE, world_wideClass))

typedef struct _world_wide world_wide;
typedef struct _world_wideClass world_wideClass;

#define TYPE_HELP (help_get_type ())
#define HELP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HELP, help))
#define HELP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HELP, helpClass))
#define IS_HELP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HELP))
#define IS_HELP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HELP))
#define HELP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HELP, helpClass))

typedef struct _help help;
typedef struct _helpClass helpClass;
typedef struct _helpPrivate helpPrivate;

typedef enum  {
	WORLD_WIDE_SCREEN_TYPE_none,
	WORLD_WIDE_SCREEN_TYPE_file_list,
	WORLD_WIDE_SCREEN_TYPE_view_list,
	WORLD_WIDE_SCREEN_TYPE_play_list,
	WORLD_WIDE_SCREEN_TYPE_ext_list,
	WORLD_WIDE_SCREEN_TYPE_debug,
	WORLD_WIDE_SCREEN_TYPE_help
} world_widescreen_type;

struct _screen {
	GTypeInstance parent_instance;
	volatile int ref_count;
	screenPrivate * priv;
	world_wide* world;
	gint screen_pos;
	gint row_pos;
	gint key_handled;
};

struct _screenClass {
	GTypeClass parent_class;
	void (*finalize) (screen *self);
	gboolean (*has_title) (screen* self);
	gchar* (*get_title) (screen* self);
	void (*previous_song) (screen* self);
	void (*advance_song) (screen* self);
	void (*continue_songs) (screen* self);
	void (*continue_songs_draw) (screen* self);
	gint (*get_size) (screen* self);
	gchar* (*calc_target) (screen* self, guint num);
	gchar* (*get_line) (screen* self, guint num);
	world_widescreen_type (*get_screen_type) (screen* self);
	void (*reset_stop) (screen* self);
	void (*draw) (screen* self);
	void (*key_press) (screen* self, gint key_num);
};

struct _help {
	screen parent_instance;
	helpPrivate * priv;
};

struct _helpClass {
	screenClass parent_class;
};

struct _helpPrivate {
	gchar** lines;
	gint lines_length1;
	gint _lines_size_;
};


static gpointer help_parent_class = NULL;

gpointer screen_ref (gpointer instance);
void screen_unref (gpointer instance);
GParamSpec* param_spec_screen (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_screen (GValue* value, gpointer v_object);
void value_take_screen (GValue* value, gpointer v_object);
gpointer value_get_screen (const GValue* value);
GType screen_get_type (void) G_GNUC_CONST;
GType world_wide_screen_type_get_type (void) G_GNUC_CONST;
gpointer world_wide_ref (gpointer instance);
void world_wide_unref (gpointer instance);
GParamSpec* param_spec_world_wide (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_world_wide (GValue* value, gpointer v_object);
void value_take_world_wide (GValue* value, gpointer v_object);
gpointer value_get_world_wide (const GValue* value);
GType world_wide_get_type (void) G_GNUC_CONST;
GType help_get_type (void) G_GNUC_CONST;
#define HELP_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_HELP, helpPrivate))
enum  {
	HELP_DUMMY_PROPERTY
};
help* help_new (world_wide* w);
help* help_construct (GType object_type, world_wide* w);
screen* screen_construct (GType object_type);
static gboolean help_real_has_title (screen* base);
static gint help_real_get_size (screen* base);
static gchar* help_real_get_line (screen* base, guint num);
static world_widescreen_type help_real_get_screen_type (screen* base);
static void help_finalize (screen* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


help* help_construct (GType object_type, world_wide* w) {
	help* self = NULL;
	world_wide* _tmp0_;
	self = (help*) screen_construct (object_type);
	_tmp0_ = w;
	((screen*) self)->world = _tmp0_;
	return self;
}


help* help_new (world_wide* w) {
	return help_construct (TYPE_HELP, w);
}


static gboolean help_real_has_title (screen* base) {
	help * self;
	gboolean result = FALSE;
	self = (help*) base;
	result = FALSE;
	return result;
}


static gint help_real_get_size (screen* base) {
	help * self;
	gint result = 0;
	gchar** _tmp0_;
	gint _tmp0__length1;
	self = (help*) base;
	_tmp0_ = self->priv->lines;
	_tmp0__length1 = self->priv->lines_length1;
	result = (gint) _tmp0__length1;
	return result;
}


static gchar* help_real_get_line (screen* base, guint num) {
	help * self;
	gchar* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	guint _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	self = (help*) base;
	_tmp0_ = self->priv->lines;
	_tmp0__length1 = self->priv->lines_length1;
	_tmp1_ = num;
	_tmp2_ = _tmp0_[_tmp1_];
	_tmp3_ = g_strdup (_tmp2_);
	result = _tmp3_;
	return result;
}


static world_widescreen_type help_real_get_screen_type (screen* base) {
	help * self;
	world_widescreen_type result = 0;
	self = (help*) base;
	result = WORLD_WIDE_SCREEN_TYPE_help;
	return result;
}


static void help_class_init (helpClass * klass) {
	help_parent_class = g_type_class_peek_parent (klass);
	SCREEN_CLASS (klass)->finalize = help_finalize;
	g_type_class_add_private (klass, sizeof (helpPrivate));
	SCREEN_CLASS (klass)->has_title = help_real_has_title;
	SCREEN_CLASS (klass)->get_size = help_real_get_size;
	SCREEN_CLASS (klass)->get_line = help_real_get_line;
	SCREEN_CLASS (klass)->get_screen_type = help_real_get_screen_type;
}


static void help_instance_init (help * self) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar** _tmp38_ = NULL;
	self->priv = HELP_GET_PRIVATE (self);
	_tmp0_ = g_strdup ("Auditive 0.1.18 copyright 2010-2013 Graeme Sheppard (www.rillion.net) " \
"GPL 3.");
	_tmp1_ = g_strdup ("");
	_tmp2_ = g_strdup ("(scroll down for more)");
	_tmp3_ = g_strdup ("");
	_tmp4_ = g_strdup ("Enter      open/start play");
	_tmp5_ = g_strdup ("Space      pause/resume");
	_tmp6_ = g_strdup ("Bkspc      stop/rewind");
	_tmp7_ = g_strdup ("\\          advance");
	_tmp8_ = g_strdup ("|          previous");
	_tmp9_ = g_strdup (", .        back/forward 5 sec");
	_tmp10_ = g_strdup ("[ ]        back/forward 60 sec");
	_tmp11_ = g_strdup ("{ }        back/forward 10%");
	_tmp12_ = g_strdup ("-          toggle auto-advance (>) or single play (-)");
	_tmp13_ = g_strdup ("q          quit");
	_tmp14_ = g_strdup ("");
	_tmp15_ = g_strdup ("Left       up a directory");
	_tmp16_ = g_strdup ("Right      child directory");
	_tmp17_ = g_strdup ("Up etc     navigate");
	_tmp18_ = g_strdup ("");
	_tmp19_ = g_strdup ("Tab        cycle name-size-date view");
	_tmp20_ = g_strdup ("Shift-Tab  sort in current view");
	_tmp21_ = g_strdup (";          most recent sort");
	_tmp22_ = g_strdup ("");
	_tmp23_ = g_strdup ("F1         help");
	_tmp24_ = g_strdup ("F2         filesystem view");
	_tmp25_ = g_strdup ("F3         play list view");
	_tmp26_ = g_strdup ("F4         external operations");
	_tmp27_ = g_strdup ("1-4        alternative keys for F1-F4");
	_tmp28_ = g_strdup ("`          debug screen");
	_tmp29_ = g_strdup ("~          re-read configuration file");
	_tmp30_ = g_strdup ("");
	_tmp31_ = g_strdup ("Invocation: auditive file/dir/.m3u");
	_tmp32_ = g_strdup ("");
	_tmp33_ = g_strdup ("It is possible to run external operations on files within auditive. Ed" \
"it");
	_tmp34_ = g_strdup ("example-config and copy it to ~/.auditive. These may be other media pl" \
"ayers");
	_tmp35_ = g_strdup ("for example.");
	_tmp36_ = g_strdup ("");
	_tmp37_ = g_strdup ("If problems occur visit the debug screen.");
	_tmp38_ = g_new0 (gchar*, 38 + 1);
	_tmp38_[0] = _tmp0_;
	_tmp38_[1] = _tmp1_;
	_tmp38_[2] = _tmp2_;
	_tmp38_[3] = _tmp3_;
	_tmp38_[4] = _tmp4_;
	_tmp38_[5] = _tmp5_;
	_tmp38_[6] = _tmp6_;
	_tmp38_[7] = _tmp7_;
	_tmp38_[8] = _tmp8_;
	_tmp38_[9] = _tmp9_;
	_tmp38_[10] = _tmp10_;
	_tmp38_[11] = _tmp11_;
	_tmp38_[12] = _tmp12_;
	_tmp38_[13] = _tmp13_;
	_tmp38_[14] = _tmp14_;
	_tmp38_[15] = _tmp15_;
	_tmp38_[16] = _tmp16_;
	_tmp38_[17] = _tmp17_;
	_tmp38_[18] = _tmp18_;
	_tmp38_[19] = _tmp19_;
	_tmp38_[20] = _tmp20_;
	_tmp38_[21] = _tmp21_;
	_tmp38_[22] = _tmp22_;
	_tmp38_[23] = _tmp23_;
	_tmp38_[24] = _tmp24_;
	_tmp38_[25] = _tmp25_;
	_tmp38_[26] = _tmp26_;
	_tmp38_[27] = _tmp27_;
	_tmp38_[28] = _tmp28_;
	_tmp38_[29] = _tmp29_;
	_tmp38_[30] = _tmp30_;
	_tmp38_[31] = _tmp31_;
	_tmp38_[32] = _tmp32_;
	_tmp38_[33] = _tmp33_;
	_tmp38_[34] = _tmp34_;
	_tmp38_[35] = _tmp35_;
	_tmp38_[36] = _tmp36_;
	_tmp38_[37] = _tmp37_;
	self->priv->lines = _tmp38_;
	self->priv->lines_length1 = 38;
	self->priv->_lines_size_ = self->priv->lines_length1;
}


static void help_finalize (screen* obj) {
	help * self;
	self = HELP (obj);
	self->priv->lines = (_vala_array_free (self->priv->lines, self->priv->lines_length1, (GDestroyNotify) g_free), NULL);
	SCREEN_CLASS (help_parent_class)->finalize (obj);
}


GType help_get_type (void) {
	static volatile gsize help_type_id__volatile = 0;
	if (g_once_init_enter (&help_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (helpClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) help_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (help), 0, (GInstanceInitFunc) help_instance_init, NULL };
		GType help_type_id;
		help_type_id = g_type_register_static (TYPE_SCREEN, "help", &g_define_type_info, 0);
		g_once_init_leave (&help_type_id__volatile, help_type_id);
	}
	return help_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



